module CPU (cpuAC, cpuAR, cpuIR, cpuPC, cpuMBUS, cpuRBUS, cpuinAbus, cpuinBbus, reset, clk);
	
	output [7:0] cpuAC, cpuAR, cpuIR, cpuPC, cpuMBUS, cpuinAbus, cpuinBbus;
	output [8:0] cpuRBUS;
	input reset, clk;
	wire rd, clr, inc, loadPC, selectAR, loadIR, loadAR, loadAC, ac8int, selectA, selectB, write_en;
	wire [2:0] alu_fn;
	wire [3:0] IRopcodebits;
	wire [4:0] ps_int;
	wire [7:0] ARint, IRint;
	wire [8:0] ACint;
	
	DU du (cpuABUS, selectAR, loadPC, inc, clr, cpuPC, loadAR, loadIR, ARint, IRint, alu_fn, loadAC, ACint, 
		   cpuRBUS,rd, cpuMBUS, selectA, selectB, write_en, cpuinAbus, cpuinBbus, clk);
			
	CU cu (clk, reset, IRopcodebits, ac8int, clr, write_en, selectB, selectA, rd, alu_fn, loadAC, loadIR, 
	       loadAR, inc, loadPC, selectAR, ps_int);
	
	assign IRopcodebits = IRint [7:4];
	assign cpuIR = IRint;
	assign cpuAC = ACint;
	assign ac8int = ACint[8];
	assign cpuAR = ARint;
	
endmodule
