module DU ( Abus,sel_AR,ldPC,incPC,clrPC,PC,ldAR,ldIR,AR,IR,f,ldAC,AC,Rbus,readM,Mbus,selA,selB,
			we,inAbus, inBbus,clk );

input ldAC,readM,clk;
input ldAR,ldIR,sel_AR,ldPC,incPC,clrPC,we,selA,selB;
input [2:0]f;
output [7:0]Abus,PC;
output [7:0]IR,AR,Mbus,inAbus,inBbus;
output [8:0]AC,Rbus;

wire [7:0] Abus_out,PCout;
wire [7:0] IRout,RAMout,inBbus,ARout,Dout1,Dout2;
wire [8:0] ACout,inAbus,ALUout;
wire high;

assign high=1;

aluN alu(inAbus[7:0],inBbus,f,ALUout);
		defparam alu.N=8;

regN accumulator (clk,high,high,ldAC,ALUout,ACout);
		defparam accumulator.N=9;

regN IntrReg (clk,high,high,ldIR,RAMout,IRout);
		defparam IntrReg.N=8;

regN AddrReg (clk,high,high,ldAR,RAMout,ARout);
		defparam AddrReg.N=8;
		
counterN PgmCounter (clk,clrPC,ldPC,incPC,Abus_out,PCout);
		defparam PgmCounter.N=8;
		
regfile R0123 (clk,IRout[3:2],IRout[1:0],IRout[3:2],we,ALUout[7:0],Dout1,Dout2);
		defparam R0123.N=8;
		
RAM ram256x8 (RAMout,ALUout[7:0],Abus_out,readM,clk);


assign inAbus = (selA?ACout[7:0]:Dout1),
	   inBbus = (selB?Dout2:RAMout),
	   Abus_out = (sel_AR?ARout:PCout),
	   PC=PCout,
	   AR=ARout,
	   IR=IRout,
	   Mbus=RAMout,
	   AC=ACout,
	   Abus=Abus_out,
	   Rbus=ALUout;
endmodule
